#!/usr/bin/env python
from os import system
from subprocess import *

data_list = ['a9a', 'real-sim', 'news20.binary','rcv1_test.binary']

eps_list = [10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0.8, 0.5, 0.3, 0.1, 0.05, 0.01, 0.005, 0.001]

def cddual_with_shrinking(data):

	#DCDL2-S
	result_list = []
	for eps  in eps_list:
		cmd = './liblinear/train -s 1 -e %lf -c 1 data/%s.train data/%s.test'\
 			%(eps, data, data)
		print cmd
		result_list.append('%s'%Popen(cmd, shell=True, stdout=PIPE).stdout.readline())
	#output
	outfile = open('log/DCDL2-S_%s'%data, 'w')
	outfile.write("".join(result_list))
	outfile.close()
	
	#DCDL1-S
	result_list = []
	for eps  in eps_list:
		cmd = './liblinear/train -s 2 -e %lf -c 1 data/%s.train data/%s.test'\
 			%(eps, data, data)
		print cmd
		result_list.append('%s'%Popen(cmd, shell=True, stdout=PIPE).stdout.readline())
	#output
	outfile = open('log/DCDL1-S_%s'%data, 'w')
	outfile.write("".join(result_list))
	outfile.close()

def cddual_without_shrinking(data):
	#DCDL2
	cmd ="./liblinear/train -s 3 -c 1 -e %s data/%s.train data/%s.test > log/DCDL2_%s"\
			%(1e-6, data, data, data)
	print cmd 
	system(cmd)
	#DCDL1
	cmd ="./liblinear/train -s 4 -c 1 -e %s data/%s.train data/%s.test > log/DCDL1_%s"\
			%(1e-6, data, data, data)
	print cmd 
	system(cmd)

for data in data_list:
	cddual_without_shrinking(data);
	cddual_with_shrinking(data);

