#!/usr/bin/env python
from os import *

data_list = ['a9a', 'real-sim', 'news20.binary','rcv1_test.binary']

eps = 1e-2
# One may use a stricter stopping condition to obtain a more accruate solution.  

def compare(data):

	#cddual_l2 (without shrinking)
	cmd ="./liblinear/train -s 3 -c 1 -e %s data/%s.train data/%s.test > log/DCDL2_%s"\
			%(eps, data, data, data)
	print cmd 
	system(cmd)

	#cdprimal

	cmd ="./liblinear/train -s 5 -c 1 -e %s data/%s.train data/%s.test > log/PCD_%s"\
			%(eps, data, data, data)
	print cmd
	system(cmd)

	#tron 
	cmd ="./liblinear/train -s 0 -c 1 -e %s data/%s.train data/%s.test > log/TRON_%s"\
			%(eps, data, data, data)
	print cmd
	system(cmd)

	
for data in data_list:
		compare(data)
